/* ^C}R[ */
#define TIMER_T0IR		((volatile unsigned int *)(0xE0004000))
#define TIMER_T0TCR		((volatile unsigned int *)(0xE0004004))
#define TIMER_T0TC		((volatile unsigned int *)(0xE0004008))
#define TIMER_T0PR		((volatile unsigned int *)(0xE000400C))
#define TIMER_T0PC		((volatile unsigned int *)(0xE0004010))
#define TIMER_T0MCR		((volatile unsigned int *)(0xE0004014))
#define TIMER_T0MR0		((volatile unsigned int *)(0xE0004018))



/* CPU荞݋ */
void CPU_EnableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val &= ~0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞݋֎~ */
void CPU_DisableInterrupt()
{
  volatile unsigned int CPSR_val;
  asm ("MRS %0, CPSR": "=r" (CPSR_val):);
  CPSR_val |= 0x80;
  asm ("MSR CPSR, %0": :"r" (CPSR_val));
}

/* CPU荞݋ */
void CPU_EnableInterrupt_SWI()
{
  volatile unsigned int SPSR_val;
  asm ("MRS %0, SPSR": "=r" (SPSR_val):);
  SPSR_val &= ~0x80;
  asm ("MSR SPSR, %0": :"r" (SPSR_val));
}

/* CPU荞݋֎~ */
void CPU_DisableInterrupt_SWI()
{
  volatile unsigned int SPSR_val;
  asm ("MRS %0, SPSR": "=r" (SPSR_val):);
  SPSR_val |= 0x80;
  asm ("MSR SPSR, %0": :"r" (SPSR_val));
}

void prefetch_abort_func(){

}

void FIQ_func(){

}

extern int LED_val;
/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))


void IRQ_func(){
  int i, loop;

  if(LED_val == 0){
    *FGPIO_FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */
    LED_val = 1;
  }
  else{
    *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
    LED_val = 0;
  }
  
  *TIMER_T0IR =1;		/* ^C}荞݃NA */
}

extern int int_status;
void UART_puts(char *s);

void software_exception_func(){

  if(int_status == 0){
    CPU_EnableInterrupt_SWI();
    int_status = 1;
    UART_puts("Int Enabled.\n\r");
  }
  else{
    CPU_DisableInterrupt_SWI();
    int_status = 0;
    UART_puts("Int Disabled.\n\r");
  }  
}
