// Copyright (c) Shinichi Yamagiwa, 2007
// ARM (LPC2388)GDBX^u _E[hTvvO

//#define IRQ_TEST
#define SWI_TEST

/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))


/* |[gRg[ */
#define PINSEL1	((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))


/* ^C}R[ */
#define TIMER_T0IR		((volatile unsigned int *)(0xE0004000))
#define TIMER_T0TCR		((volatile unsigned int *)(0xE0004004))
#define TIMER_T0TC		((volatile unsigned int *)(0xE0004008))
#define TIMER_T0PR		((volatile unsigned int *)(0xE000400C))
#define TIMER_T0PC		((volatile unsigned int *)(0xE0004010))
#define TIMER_T0MCR		((volatile unsigned int *)(0xE0004014))
#define TIMER_T0MR0		((volatile unsigned int *)(0xE0004018))


/* 荞݃Rg[(VIC) */
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))

void software_exception_func(){

}

void prefetch_abort_func(){

}

void FIQ_func(){

}

int LED_val;

void IRQ_func(){
  int i, loop;

  if(LED_val == 0){
    *FGPIO_FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */
    LED_val = 1;
  }
  else{
    *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
    LED_val = 0;
  }
  
  *TIMER_T0IR =1;		/* ^C}荞݃NA */
}

/* CPUŗL */
void CPU_Initialize(void)
{
  /*** PLLNbNU ***/

  /* łPLL쒆ꍇ͒~ */
  if ( *CLK_PLLSTAT & (1<<25) ) {
    /* PLLCON - PLL Enable & disconnected */
    *CLK_PLLCON   =0x00000001;
    /* PLL Feed operation */
    *CLK_PLLFEED  =0x000000AA;
    *CLK_PLLFEED  =0x00000055;
  }
  /* PLLCON - PLL Disable & disconnected(PLLS~) */
  *CLK_PLLCON   =0x00000000;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  *SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
  while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

  /* CLKSRCSEL - MASTER oscillator select */
  *CLK_CLKSRCSEL=0x00000001;

  /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
  *CLK_PLLCFG   =0x000B008F;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* PLLCON - PLL Enable & disconnected */
  *CLK_PLLCON   =0x00000001;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* CPU Clock Divider 1/4 */
  *CLK_CCLKCFG  =0x00000003;
  /* USB Clock Divider 1/6 */
  *CLK_USBCLKCFG=0x00000005;

  while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

  /* PLLCON - PLL Enable & Connected */
  *CLK_PLLCON   =0x00000003;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;
  while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

int main(){
  int i, j;

  CPU_Initialize();

  *SYS_SCS = *SYS_SCS | 1;	/* FGPIO Select */
  // LEDP1[18]ɐڑĂ̂ŁAfW^I/Oɐݒ
  *PINSEL1 =0;			/* GPIO Select */
  *GPIO_PINMODE1=0;			/* PullUp Enable */

  /* LED_ݒ */
  *FGPIO_FIO1DIR =0x00040000;	/* P1[18] OutPut */
  *FGPIO_FIO1MASK=0x00000000;	/* P1[18] Non Mask */
  *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */

  /* ^C}Rg[ւ̋NbNݒ */
  /* CPUNbNƓ */
  // *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3) | (1 << 2);
  /* CPUNbN1/2 */
  // *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3) | (1 << 3);
  // CPUNbN1/4 */
  *CLK_PCLKSEL0 = (*CLK_PCLKSEL0 & 0xfffffff3);

  /* ^C}0̃p[^ݒ */
  *TIMER_T0PR  = 0x00000000;		/* vXP[ */
  *TIMER_T0MR0 = 18000000;		/* NbNg=1b */
  *TIMER_T0MCR = 0x00000003;		/* MatchTCNA&荞 */


#ifdef IRQ_TEST
  *TIMER_T0TCR = 1;	/* ^C}X^[g*/

  LED_val = 0; // LED̏ԂɂB

  /* 荞݃Rg[ݒ */
  *VIC_IntSelect = *VIC_IntSelect & (~0x10);	/* IRQI */
  *VIC_IntEnable = 0x10;	/* ^C}0̂ݗL */
#endif

#ifdef SWI_TEST
  // LED̓_
  for(i=0;i<100;i++){
    *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
    for(j=0;j<1000000;j++){}
    *FGPIO_FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */
    for(j=0;j<1000000;j++){}
  }
#endif

  while(1){}
  return 0;
}
