/* CQ Monitor Target Functions */
/* Copyright (C) Shinichi Yamagiwa */

#include<stdio.h>

#include "monitor.h"

/* 荞݃Rg[(VIC) */
#define VIC_IRQStatus	((volatile unsigned int *)(0xFFFFF000))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))

#define UART_INT_BIT 0x00000040

#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))


// stdin̊荞݂֎~Ԃɂ
void init_stdin_int(){
  /* 荞݃Rg[ݒ(UARTx) */
  *VIC_IntSelect = *VIC_IntSelect & (~UART_INT_BIT);
  *VIC_IntEnable = *VIC_IntEnable |   UART_INT_BIT;
}

// stdin̊荞݂
void enable_stdin_int(){
  *COM_IER =1;
}

// stdin̊荞݂֎~
void disable_stdin_int(){
  *COM_IER =0;
}

extern unsigned int monitor_registers[];
void show_register(){
  int i;

  for(i=0;i<16;i++)
    printf("r%d\t=\t0x%.8x\r\n",i,monitor_registers[i]);
  printf("cpsr\t=\t0x%.8x\r\n",i,monitor_registers[16]);
}    
