#include <stdio.h>
#include <stdlib.h>

#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

/* 荞݃Rg[(VIC) */
#define VIC_IRQStatus	((volatile unsigned int *)(0xFFFFF000))
#define VIC_IntSelect   ((volatile unsigned int *)(0xFFFFF00C))
#define VIC_IntEnable   ((volatile unsigned int *)(0xFFFFF010))

#define UART_INT_BIT 0x00000040

int IRQ_func(){
  char c;
  if((*VIC_IRQStatus & (1<<6))){ // UART0
    if(((*COM_IIR >> 1) & 0x7) == 0x2){ // Receive Data Available
      printf("Interrupt!\r\n");
      while((c = getchar()) != 'q')
	putchar(c);
    }
  }
}

/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* |[gRg[ */
#define PINSEL0			((volatile unsigned int *)(0xE002C000))
#define PINSEL1			((volatile unsigned int *)(0xE002C004))
#define GPIO_PINMODE1	((volatile unsigned int *)(0xE002C044))

/* FGPIORg[ */
#define FGPIO_FIO1DIR	((volatile unsigned int *)(0x3FFFC020))
#define FGPIO_FIO1MASK	((volatile unsigned int *)(0x3FFFC030))
#define FGPIO_FIO1PIN	((volatile unsigned int *)(0x3FFFC034))
#define FGPIO_FIO1SET	((volatile unsigned int *)(0x3FFFC038))
#define FGPIO_FIO1CLR	((volatile unsigned int *)(0x3FFFC03C))

/* NbNp[Rg[ */
#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))


/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))

/* CPUŗL */
static void CPU_Initialize(void)
{
  /*** PLLNbNU ***/

  /* łPLL쒆ꍇ͒~ */
  if ( *CLK_PLLSTAT & (1<<25) ) {
    /* PLLCON - PLL Enable & disconnected */
    *CLK_PLLCON   =0x00000001;
    /* PLL Feed operation */
    *CLK_PLLFEED  =0x000000AA;
    *CLK_PLLFEED  =0x00000055;
  }
  /* PLLCON - PLL Disable & disconnected(PLLS~) */
  *CLK_PLLCON   =0x00000000;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  *SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
  while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

  /* CLKSRCSEL - MASTER oscillator select */
  *CLK_CLKSRCSEL=0x00000001;

  /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
  *CLK_PLLCFG   =0x000B008F;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* PLLCON - PLL Enable & disconnected */
  *CLK_PLLCON   =0x00000001;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* CPU Clock Divider 1/4 */
  *CLK_CCLKCFG  =0x00000003;
  /* USB Clock Divider 1/6 */
  *CLK_USBCLKCFG=0x00000005;

  while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

  /* PLLCON - PLL Enable & Connected */
  *CLK_PLLCON   =0x00000003;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;
  while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

int main(){
  int i,j;

  CPU_Initialize();

  *SYS_SCS = *SYS_SCS | 1;	/* FGPIO Select */
  // LEDP1[18]ɐڑĂ̂ŁAfW^I/Oɐݒ
  *PINSEL1 =0;			/* GPIO Select */
  *GPIO_PINMODE1=0;			/* PullUp Enable */

  /* LED_ݒ */
  *FGPIO_FIO1DIR =0x00040000;	/* P1[18] OutPut */
  *FGPIO_FIO1MASK=0x00000000;	/* P1[18] Non Mask */
  *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */

  /* 荞݃Rg[ݒ(UARTx) */
  *VIC_IntSelect = *VIC_IntSelect & (~UART_INT_BIT);
  *VIC_IntEnable = *VIC_IntEnable |   UART_INT_BIT;
  
  *COM_IER =1;		/* M荞ݎgp */

  printf("Start Newlib Sample\r\n");

  // LED̓_
  for(;;){
    *FGPIO_FIO1PIN =0x00040000;	/* P1[18] '1' -> LED OFF */
    for(j=0;j<100000;j++){}
    *FGPIO_FIO1PIN =0x00000000;	/* P1[18] '0' -> LED ON */
    for(j=0;j<100000;j++){}
  }

  while(1){}

  return 1;
}
