// System call functions for target system 
// Copyrght (C) Shinichi Yamagiwa

// LPC2388^[QbgɂĂ܂B

/* ============== ^[Qbg`Ɗ֐ ============= */
#define COM_BaseAdr	0xE000C000	/* UART0 x[XAhX */
#define COM_RBR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_THR			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLL			((volatile unsigned char *)(COM_BaseAdr+0x00))
#define COM_DLM			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IER			((volatile unsigned char *)(COM_BaseAdr+0x04))
#define COM_IIR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_FCR			((volatile unsigned char *)(COM_BaseAdr+0x08))
#define COM_LCR			((volatile unsigned char *)(COM_BaseAdr+0x0C))
#define COM_LSR			((volatile unsigned char *)(COM_BaseAdr+0x14))
#define COM_SCR			((volatile unsigned char *)(COM_BaseAdr+0x1C))
#define COM_FDR			((volatile unsigned char *)(COM_BaseAdr+0x28))

static char RecvData(){
  while((*COM_LSR & 0x1) == 0){};	/* CEXe[^X擾 */
  return (unsigned char)*COM_RBR;	/* Mf[^Ԃ */
}

static void SendData(char data){
  while((*COM_LSR & 0x20)==0) {}	/* Mobt@󂭂܂ő҂ */
  *COM_THR = (unsigned char)data;	/* Mf[^ */
}

/* VXeRg[ */
#define SYS_SCS			((volatile unsigned int *)(0xE01FC1A0))

/* NbNp[Rg[䃌WX^ */
#define CLK_PLLCON		((volatile unsigned int *)(0xE01FC080))
#define CLK_PLLCFG		((volatile unsigned int *)(0xE01FC084))
#define CLK_PLLSTAT		((volatile unsigned int *)(0xE01FC088))
#define CLK_PLLFEED		((volatile unsigned int *)(0xE01FC08C))

#define CLK_CCLKCFG		((volatile unsigned int *)(0xE01FC104))
#define CLK_USBCLKCFG	((volatile unsigned int *)(0xE01FC108))
#define CLK_CLKSRCSEL	((volatile unsigned int *)(0xE01FC10C))

#define CLK_PCLKSEL0	((volatile unsigned int *)(0xE01FC1A8))
#define CLK_PCLKSEL1	((volatile unsigned int *)(0xE01FC1AC))

/* CPUŗL */
static void CPU_Initialize(void)
{
  /*** PLLNbNU ***/

  /* łPLL쒆ꍇ͒~ */
  if ( *CLK_PLLSTAT & (1<<25) ) {
    /* PLLCON - PLL Enable & disconnected */
    *CLK_PLLCON   =0x00000001;
    /* PLL Feed operation */
    *CLK_PLLFEED  =0x000000AA;
    *CLK_PLLFEED  =0x00000055;
  }
  /* PLLCON - PLL Disable & disconnected(PLLS~) */
  *CLK_PLLCON   =0x00000000;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  *SYS_SCS = 0x21;	/* 12MHz OSC Enable & FGPIO Select */
  while((*SYS_SCS&0x40) == 0){}	/* OSCSTAT Wait */

  /* CLKSRCSEL - MASTER oscillator select */
  *CLK_CLKSRCSEL=0x00000001;

  /* PLLCFG - MCLK=12MHz use, FCC0 = 288MHz M=144,N=12 */
  *CLK_PLLCFG   =0x000B008F;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* PLLCON - PLL Enable & disconnected */
  *CLK_PLLCON   =0x00000001;
  /* PLL Feed operation */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;

  /* CPU Clock Divider 1/4 */
  *CLK_CCLKCFG  =0x00000003;
  /* USB Clock Divider 1/6 */
  *CLK_USBCLKCFG=0x00000005;

  while ( ((*CLK_PLLSTAT & (1<<26)) == 0) ); /* Check lock bit status */

  /* PLLCON - PLL Enable & Connected */
  *CLK_PLLCON   =0x00000003;
  /* PLL Feed operation. */
  *CLK_PLLFEED  =0x000000AA;
  *CLK_PLLFEED  =0x00000055;
  while ( ((*CLK_PLLSTAT & (1<<25)) == 0) ); /* Check connect bit status */
}

/* |[gRg[ */
#define PINSEL0			((volatile unsigned int *)(0xE002C000))
/* NbNp[Rg[ */
#define POW_PCONP		((volatile unsigned int *)(0xE01FC0C4))

static int UART_Initialized = 0;

static void UART_Initialize(){

  CPU_Initialize();

  // UARTTXD0RXD0g
  /* |[gUART[hɐݒ(UART0) */
  *PINSEL0=(*PINSEL0 & 0xFFFFFF0F) | 0x50;	/* TXD0&RXD0I */
  /* UART0NbN 72MHz/4=18MHz */
  *CLK_PCLKSEL0=(*CLK_PCLKSEL0 & 0xFFFFFF3F);
  /* UART0p[Cl[u */
  *POW_PCONP = *POW_PCONP | 8;	/* UART0 */

  /* UARTݒ */
  *COM_LCR =0x80;   /* ݒ背WX^I */
  *COM_DLL =37;     /* 18MHz19200bpsݒ */
  *COM_DLM =0;
  *COM_FDR =(/*MULVAL=*/ 12 <<4)|/*DIVADDVAL=*/7; /* FDRWX^ݒ */
  *COM_LCR =0x03;		/* peBȂ/Xgbvrbg1/f[^8rbg */


}

#include "target_syscalls.h"

// stdoutĂꍇ1AĂȂꍇ0Ԃ֐
int __StdOutIsInitialized(){
  if(UART_Initialized == 0){
    return 0;
  }
  return 1;
}

// stdout֐Bs0Ԃ
int __InitializeStdOut(){
  UART_Initialize();
  UART_Initialized = 1;
  return 1;
}

// stdoutɏo͂֐B
// buf͕ւ̃|C^B
// lenbuf̒B
// o͂ɐԂB
int __OutputToStdOut(unsigned char *buf, int len){
  int i;
  
  for(i=0;i<len;i++)
    SendData(buf[i]);

  return len;
}

// stdinĂꍇ1AĂȂꍇ0Ԃ֐
int __StdInIsInitialized(){
  if(UART_Initialized == 0){
    return 0;
  }
  return 1;
}

// stdin֐Bs0Ԃ
int __InitializeStdIn(){
  UART_Initialize();
  UART_Initialized = 1;
  return 1;
}

// stdin͂֐B
// buf͓͗pobt@ւ̃|C^B
// lenbuf̒B
// o͂ɐԂB
int __InputFromStdIn(unsigned char *buf, int len){
  buf[0] = RecvData();
  return 1;
}

// ^C}[ANeBuł͂ȂƂA0ԂB
int __TimerIsActive(){
  
  return 1;
}

// ^C}[AANeBuɂ֐Bs0ԂB
int __ActivateTimer(){

  return 1;
}

// ݂̃^C}[̕bƃ}CNb擾֐Bs0ԂB
int __GetCurrTime(int *sec, int *usec){
  
  return 1;
}


